diff --git a/Makefile b/Makefile
index 0b29820..a01b10d 100644
--- a/Makefile
+++ b/Makefile
@@ -140,7 +140,7 @@ coverage-output-text:
 
 coverage-output:
 	rm -rf coverage-html
-	coverage html -d coverage-html $(COVERAGE_OMIT)
+	coverage html -i -d coverage-html $(COVERAGE_OMIT)
 	cp .coverage coverage-html/coverage.data
 	@echo "now point your browser at coverage-html/index.html"
 
@@ -184,6 +184,8 @@ endif
 
 pyflakes:
 	$(PYTHON) -OOu `which pyflakes` src/allmydata |sort |uniq
+check-umids:
+	$(PYTHON) misc/check-umids.py `find src/allmydata -name '*.py'`
 
 count-lines:
 	@echo -n "files: "
diff --git a/misc/check-umids.py b/misc/check-umids.py
new file mode 100755
index 0000000..05e8825
--- /dev/null
+++ b/misc/check-umids.py
@@ -0,0 +1,30 @@
+#! /usr/bin/python
+
+# ./rumid.py foo.py
+
+import sys, re, os
+
+ok = True
+umids = {}
+
+for fn in sys.argv[1:]:
+    fn = os.path.abspath(fn)
+    for lineno,line in enumerate(open(fn, "r").readlines()):
+        lineno = lineno+1
+        if "umid" not in line:
+            continue
+        mo = re.search("umid=[\"\']([^\"\']+)[\"\']", line)
+        if mo:
+            umid = mo.group(1)
+            if umid in umids:
+                oldfn, oldlineno = umids[umid]
+                print "%s:%d: duplicate umid '%s'" % (fn, lineno, umid)
+                print "%s:%d: first used here" % (oldfn, oldlineno)
+                ok = False
+            umids[umid] = (fn,lineno)
+
+if ok:
+    print "all umids are unique"
+else:
+    print "some umids were duplicates"
+    sys.exit(1)
diff --git a/misc/coverage.el b/misc/coverage.el
index bad490f..8d69d5d 100644
--- a/misc/coverage.el
+++ b/misc/coverage.el
@@ -84,7 +84,8 @@
                            'face '(:box "red")
                            )
               )
-            (message "Added annotations")
+            (message (format "Added annotations: %d uncovered lines"
+                             (safe-length uncovered-code-lines)))
             )
           )
       (message "unable to find coverage for this file"))
diff --git a/misc/coverage2el.py b/misc/coverage2el.py
index ed94bd0..7d03a27 100644
--- a/misc/coverage2el.py
+++ b/misc/coverage2el.py
@@ -1,5 +1,5 @@
 
-from coverage import coverage, summary
+from coverage import coverage, summary, misc
 
 class ElispReporter(summary.SummaryReporter):
     def report(self):
@@ -21,7 +21,10 @@ class ElispReporter(summary.SummaryReporter):
         out.write("(let ((results (make-hash-table :test 'equal)))\n")
         for cu in self.code_units:
             f = cu.filename
-            (fn, executable, missing, mf) = self.coverage.analysis(cu)
+            try:
+                (fn, executable, missing, mf) = self.coverage.analysis(cu)
+            except misc.NoSource:
+                continue
             code_linenumbers = executable
             uncovered_code = missing
             covered_linenumbers = sorted(set(executable) - set(missing))
diff --git a/src/allmydata/client.py b/src/allmydata/client.py
index 12e7473..b01fbe8 100644
--- a/src/allmydata/client.py
+++ b/src/allmydata/client.py
@@ -12,11 +12,11 @@ import allmydata
 from allmydata.storage.server import StorageServer
 from allmydata import storage_client
 from allmydata.immutable.upload import Uploader
-from allmydata.immutable.download import Downloader
+from allmydata.immutable.download2_util import Terminator
 from allmydata.immutable.offloaded import Helper
 from allmydata.control import ControlServer
 from allmydata.introducer.client import IntroducerClient
-from allmydata.util import hashutil, base32, pollmixin, cachedir, log
+from allmydata.util import hashutil, base32, pollmixin, log
 from allmydata.util.abbreviate import parse_abbreviated_size
 from allmydata.util.time_format import parse_duration, parse_date
 from allmydata.stats import StatsProvider
@@ -278,12 +278,9 @@ class Client(node.Node, pollmixin.PollMixin):
 
         self.init_client_storage_broker()
         self.history = History(self.stats_provider)
+        self.terminator = Terminator()
+        self.terminator.setServiceParent(self)
         self.add_service(Uploader(helper_furl, self.stats_provider))
-        download_cachedir = os.path.join(self.basedir,
-                                         "private", "cache", "download")
-        self.download_cache_dirman = cachedir.CacheDirectoryManager(download_cachedir)
-        self.download_cache_dirman.setServiceParent(self)
-        self.downloader = Downloader(self.storage_broker, self.stats_provider)
         self.init_stub_client()
         self.init_nodemaker()
 
@@ -342,8 +339,7 @@ class Client(node.Node, pollmixin.PollMixin):
                                    self._secret_holder,
                                    self.get_history(),
                                    self.getServiceNamed("uploader"),
-                                   self.downloader,
-                                   self.download_cache_dirman,
+                                   self.terminator,
                                    self.get_encoding_parameters(),
                                    self._key_generator)
 
diff --git a/src/allmydata/immutable/checker.py b/src/allmydata/immutable/checker.py
index 2f2d8f1..31c70e3 100644
--- a/src/allmydata/immutable/checker.py
+++ b/src/allmydata/immutable/checker.py
@@ -85,7 +85,9 @@ class Checker(log.PrefixingLogMixin):
             level = log.WEIRD
             if f.check(DeadReferenceError):
                 level = log.UNUSUAL
-            self.log("failure from server on 'get_buckets' the REMOTE failure was:", facility="tahoe.immutable.checker", failure=f, level=level, umid="3uuBUQ")
+            self.log("failure from server on 'get_buckets' the REMOTE failure was:",
+                     facility="tahoe.immutable.checker",
+                     failure=f, level=level, umid="AX7wZQ")
             return ({}, serverid, False)
 
         d.addCallbacks(_wrap_results, _trap_errs)
